rawset(_G, "TestCutscene", function(d, mobj)
	if mobj and mobj.valid
		mobj.player.pflags = $|PF_FULLSTASIS
		if d > 29*TICRATE
		and d <= 30*TICRATE
			P_InstaThrust(mobj, mobj.angle, 35*FRACUNIT)
			if mobj.state ~= S_PLAY_RUN
				mobj.state = S_PLAY_RUN
			end
		elseif d <= 29*TICRATE
		and d > (28*TICRATE) - TICRATE/20
			P_InstaThrust(mobj, mobj.player.drawangle, 35*FRACUNIT)
			P_SetObjectMomZ(mobj, (d - ((28*TICRATE) - TICRATE/20))*FRACUNIT, false)
			if mobj.state ~= S_PLAY_JUMP
				mobj.state = S_PLAY_JUMP
			end
			P_TeleportCameraMove(camera, 1700*FRACUNIT, 1461*FRACUNIT, 719*FRACUNIT + mobj.height)
			camera.angle = ANGLE_225
		elseif d <= (28*TICRATE) - TICRATE/20
		and d > 27*TICRATE + TICRATE/2
			mobj.angle = ANGLE_135
			mobj.player.drawangle = ANGLE_135
			P_InstaThrust(mobj, mobj.angle, 35*FRACUNIT)
			if mobj.state ~= S_PLAY_RUN
				mobj.state = S_PLAY_RUN
			end
		elseif d <= 27*TICRATE + TICRATE/2
		and d > 27*TICRATE
			P_InstaThrust(mobj, mobj.angle, 0*FRACUNIT)
			P_SetObjectMomZ(mobj, -20*FRACUNIT, false)
			if mobj.state ~= S_PLAY_ROLL
				mobj.state = S_PLAY_ROLL
			end
		elseif d <= 27*TICRATE
		and d > 25*TICRATE
			P_InstaThrust(mobj, mobj.angle, 35*FRACUNIT)
			if mobj.state ~= S_PLAY_RUN
				mobj.state = S_PLAY_RUN
			end
		elseif d <= 25*TICRATE
		and d > 24*TICRATE
			mobj.angle = ANGLE_112h
			mobj.player.drawangle = ANGLE_112h
			P_InstaThrust(mobj, mobj.angle, 35*FRACUNIT)
			P_SetObjectMomZ(mobj, 10*FRACUNIT, false)
			if mobj.state ~= S_PLAY_RUN
				mobj.state = S_PLAY_RUN
			end
		elseif d <= 24*TICRATE
		and d > 23*TICRATE - TICRATE/20
			mobj.angle = ANGLE_45
			mobj.player.drawangle = ANGLE_45
			P_InstaThrust(mobj, mobj.angle, 35*FRACUNIT)
			P_SetObjectMomZ(mobj, (d - ((23*TICRATE) - TICRATE/20))*FRACUNIT, false)
			if mobj.state ~= S_PLAY_JUMP
				mobj.state = S_PLAY_JUMP
			end
		else
			d = 0
			mobj.flags = $ & ~PF_FULLSTASIS
		end
	end
end)

addHook("PlayerSpawn", function(player)
    if player.mo and player.mo.valid
	and gamemap == 1
        local obj = {}
        table.insert(obj, player.mo)
        CM_AddCutscene("testcutscene", 30*TICRATE, obj, TestCutscene, true)
        CM_StartCutscene("testcutscene")
    end
end)