rawset(_G, "CutsceneEnviroment", {})

rawset(_G, "CM_AddCutscene", function(name, duration, objects, func, replace)
	if CutsceneEnviroment[name] == nil
		CutsceneEnviroment[name] = {}
		CutsceneEnviroment[name].d = duration
		CutsceneEnviroment[name].md = duration
		CutsceneEnviroment[name].o = objects
		CutsceneEnviroment[name].f = func
		CutsceneEnviroment[name].s = false
	else
		if replace == nil
		or not replace
			print "Already existing cutscene!"
		else
			CM_ReplaceCutscene(name, duration, objects, func)
		end
	end
end)

rawset(_G, "CM_ReplaceCutscene", function(name, duration, objects, func, replace)
	if name ~= nil
	and CutsceneEnviroment[name] ~= nil
		if duration ~= nil
			CutsceneEnviroment[name].d = duration
			CutsceneEnviroment[name].md = duration
		end
		if objects ~= nil
			CutsceneEnviroment[name].o = objects
		end
		if func ~= nil
			CutsceneEnviroment[name].f = func
		end
	else
		print "We kinda need a name to replace stuff"
	end
end)

rawset(_G, "CM_StartCutscene", function(name)
	CutsceneEnviroment[name].s = true
end)

rawset(_G, "CM_DeleteCutscene", function(name)
	CutsceneEnvironment[name] = nil
end)

addHook("ThinkFrame", function()
	for _, v in pairs(CutsceneEnviroment)
		if v.s
			if v.d <= 0
				v.d = v.md
				v.s = false
				continue
			end
			for _, m in pairs(v.o)
				v.f(v.d, m)
			end
			v.d = $ - 1
		end
	end
end)